Subject: bug#77438: [FEATURE REQUEST] Freely positioning the cursor anywhere in the buffer (Vimâs virtualedit=all Equivalent in Emacs)

From: James Cherti <[email-masked]>
Date: Thu, 3 Apr 2025 11:30:12 -0400

Hello Richard,

On 2025-04-02 23:36, Richard Stallman wrote:
> [[[ To any NSA and FBI agents reading my email: please consider    ]]]
> [[[ whether defending the US Constitution against all enemies,     ]]]
> [[[ foreign or domestic, requires you to follow Snowden's example. ]]]
> 
>    > Unlike Vim's `virtualedit=all` mode, Emacs' quarter-plane,
>    > picture-mode, and artist-mode packages insert actual spaces into the
>    > buffer. In contrast, Vim’s `set virtualedit=all` allows the cursor to
>    > be placed in positions where no text exists, but real spaces are not
>    > added until a character is typed.
> 
> This won't be exactly easy to do in Emacs.  It is fundamental in Emacs
> that point is on a position between two characters.

Thank you for taking the time to comment on this feature request, which
I hope to see implemented in Emacs.

Could this be implemented without modifying the fundamental concept
in Emacs that a point is a position between two characters?

Here’s an idea: instead of modifying the internal concept where the
cursor is equal to the position between two characters, we could
implement a new mode that displays a "virtual cursor." This mode
would display a cursor representing a specific line/column, rather
than a position between two characters. It would allow the cursor to
be placed at a line/column position, which may not necessarily be
between two characters.

> -- Dr Richard Stallman (https://stallman.org) Chief GNUisance of the GNU 
> Project (https://gnu.org) Founder, Free Software Foundation (https:// 
> fsf.org) Internet Hall-of-Famer (https://internethalloffame.org)

--
James Cherti
GitHub: https://github.com/jamescherti
Website: https://www.jamescherti.com/